VARIABLES = {};
OBJETS = {};

PROC={
	init : function(){
		VARIABLES = {};
		OBJETS = {};
	},
	
	setObjet : function(name, obj){
		if(!name || !obj){return false;}
		OBJETS[name]=obj;
	},
	remonte : function(node, root, tagName){
		if(!node){return false;}
		if(tagName){
			tagName=tagName.toLowerCase();
			tags=tagName.split(' ');
		}
		var html=document.querySelector('html');
		root=root ? root : html;
		if(node==root || node==html){
			return false;
		}
		else{
			var parent=node.parentElement;
			if(parent.tagName.toLowerCase()==tagName){
				return parent;
			}
			else{
				return PROC.remonte(parent, root, tagName);
			}
		}
	},
	remonteDroite : function(node, root){
		if(!node){return false;}
		if(!root){root=document.querySelector('html');}
		if(node==root || (!node)){return false;}
		else{
			if(node.nextElementSibling){return node.nextElementSibling;}
			else if(node.parentElement && node.parentElement.getAttribute('repeat')=='true'){return node.parentElement;}
			else{return PROC.remonteDroite(node.parentElement, root);}
		}
	},
		
	next : function(node, root, tagName){//Modifier pour tenir compte des éléments vides container
		if(node && root && node!=root && !UTIL.isParent(node,root)){
			console.log("node n'est pas sous le root de next : ");console.log(node);console.log(root);
			return false;
		}
		
		if(node && node.tagName.toLowerCase()=='goto' && node.getAttribute('target')){
			var doc=root ? root : document;
			var nextNode=doc.querySelector(node.getAttribute('target'));
			if(nextNode){
				return nextNode;}
		}
		
		var tags=[];
		if(tagName){
			tagName=tagName.toLowerCase();
			tags=tagName.split(' ');
		}
		if(!node){
			var nextNode=root.firstElementChild ? root.firstElementChild : false;//pour faciliter certaines init
		}
		else if(node.getAttribute('container')=='true' && node.getAttribute('ignore')!='true'){
			var nextNode=node.firstElementChild ? node.firstElementChild : PROC.remonteDroite(node, root);
		}
		else{
			var nextNode=node.nextElementSibling ? node.nextElementSibling : PROC.remonteDroite(node, root);
		}
		PROC.processXML(nextNode);//attention, pourrait poser des soucis en cas de recherche infructueuse (?)
		if(nextNode && (
				nextNode.getAttribute('ignore')=='true' || 
				nextNode.getAttribute('container')=='true' || 
				(tagName && tags.indexOf(nextNode.tagName.toLowerCase()) == -1)
		) ){
			nextNode=PROC.next(nextNode, root, tagName);
		}
		return nextNode;
	},
	
	setVariable : function(variable, valeur){
		if(!variable){return;}
		if(valeur){
			var valeur_trad=PROC.traduction_str_var(valeur);
			VARIABLES[variable]=eval(valeur_trad);
		}
		else{
			var valeur_trad=undefined;
			VARIABLES[variable]=undefined;
		}
	},
	
	getVariable : function(variable, valeur){
		if(valeur in VARIABLES){
			console.log(VARIABLES[variable]);
			return VARIABLES[variable];
		}
		else{
			console.log(undefined);
		}
	},
	traduction_str_var : function(str){
		var varNames=str.match(UTIL.RE.alpha_num_name);
		if(!varNames){return str;}
		str=' '+str;
		varNames.sort();
		for(var i=varNames.length-1;i>=0;i--){//en sens inverse pour ne pas remplacer x dans x2 par exemple.
			var name=varNames[i];
			var rg=new RegExp("([^\.])"+name);
			if(name in VARIABLES){
				str=str.replace(rg,"$1VARIABLES."+name);
			}
			else if(name in OBJETS){
				var rg=new RegExp("([^\.])"+name);
				str=str.replace(rg,"$1OBJETS."+name);
			}
		}
		//signes <, >, &, | échappés par \lt, \gt, \and et \or
		str=str.replace('\\lt','<');
		str=str.replace('\\gt','>');
		str=str.replace('\\and','&');
		str=str.replace('\\or','|');
		
		return str;
	},
	eval_condition : function(cond){
		var cond=PROC.traduction_str_var(cond);
		var cond_eval=false;
		try{
			cond_eval=eval(cond);
		}
		catch(e){
			cond_eval=false;
		}
		return cond_eval;
	},
	//permet de traiter en amont les modifieurs du type <if></if>, <red></red>, ...
	//un noeud non raccordé au reste du DOM sera créé si un modifieur apparaît
	//ne modifie pas la structure du DOM mais modifie des attributs, à traiter après...
	processXML : function(node, recursif){
		if(!node){return;}
		var tag=node.tagName.toLowerCase();
		var cond=node.getAttribute("condition");
		if(cond && tag!='if' && tag!='while'){
			var toto=PROC.eval_condition(cond);
			if(!PROC.eval_condition(cond)){
				node.setAttribute('ignore', 'true');
			}
			else{
				node.removeAttribute('ignore');
			}
		}
		switch(tag){
			case 'if':
				var cond=node.getAttribute("condition");
				node.setAttribute('container','true');
				if(node.children.length>0 && node.children[0].tagName.toLowerCase()=='then'){
					var then_node=node.children[0];
				}
				else{
					var then_node=node;
					//vérification qu'il n'y a pas de then ou de else plus loin dans les children (:scope >)
					for(var i=0;i<node.children.length;i++){
						if(['if','then'].indexOf(node.children[i].tagName.toLowerCase())>-1){
							console.log(node);
							throw("Structure <if><then>...</then><else>...</else></if> non respectée.");
						}
					}
				}
				then_node.setAttribute('container','true');
				
				if(node.children.length>1 && node.children[1].tagName.toLowerCase()=='else'){
					var else_node=node.children[1];
					else_node.setAttribute('container','true');
				}
				
				if(PROC.eval_condition(cond)){
					UTIL.removeAttr(then_node, 'ignore');//recursif=true
					if(else_node){
						UTIL.setAttr(else_node, 'ignore', 'true');
					}
				}
				else{
					UTIL.setAttr(then_node,'ignore', 'true');
					if(else_node){
						UTIL.removeAttr(else_node, 'ignore');
					}
				}
			break;
			case 'else':
				if(node.parentElement.tagName.toLowerCase()!='if'){
					UTIL.setAttr(node,'ignore','true');
				}
			break;
			case 'then':
				if(node.parentElement.tagName.toLowerCase()!='if'){
					UTIL.setAttr(node,'ignore','true');
				}
			break;
			case 'while':
				var cond=node.getAttribute("condition");
				node.setAttribute('container','true');
				
				if(PROC.eval_condition(cond)){
					UTIL.removeAttr(node, 'ignore');//recursif=true
					UTIL.setAttr(node, 'repeat', 'true');
				}
				else{
					UTIL.setAttr(node,'ignore', 'true');
					UTIL.removeAttr(node, 'repeat');
				}
			break;
			case 'set':
				var nomVar = node.getAttribute("var");
				if(nomVar!=undefined && node.getAttribute("ignore")!='true'){
					PROC.setVariable(nomVar, node.getAttribute("val"));
				}
			break;
			case 'get':
				var nomVar = node.getAttribute("var");
				if(nomVar!=undefined){
					PROC.getVariable(nomVar);
				}
			break;
			default:
				//
			break;
		}
		//relance sur les noeuds fils :
		if(recursif){
			for(var i=0;i<node.children.length;i++){
				PROC.processXML(node.children[i], true);
			}
		}
		return node;
	}
}
