
///////////////////////////////////////////////
//                  Scene                    //
///////////////////////////////////////////////
// class Scene{
Scene=function(options){
	this.initDOM=function(){
		var that=this;		
		this.rootDOM = UTIL.findOrCreate('#theatre');
	}
	
	this.setScene=function(options){
		options=UTIL.options2json(options);
		console.log("options")
		console.log(options)
		if(typeof options=="string" || !options){
			throw("Element DOM non trouvé pour créer instance de Scene");
		}
		else if('XML' in options){
			this.XML=options.XML;
		}
		else if('XML' in options){
			this.XML=options.XML;
		}
		else if('scene' in options){
			this.XML=options.scene;
		}
		else{
			throw("Pas d'élément 'XML' permettant d'instancier la Scene");
		}
		UTIL.setOptions(this, options, Scene.CONST.options_defaut);
		
		
		//Découpage des éléments séquencés :
		for(var i=0;i<this.XML.childNodes.length;i++){
			this.XML.childNodes[i].display="none";
		}
		this.initialisation();
	}
	
	this.initialisation=function(){
		this.fini=false;
		this.pause=true;
		
		this.variables={};
		this.dummy_element={fini:true, start:function(){return;}};
		
		this.sequences=[];
		this.elements={
			personnages:{},
			messages:{},
			decors:{},
			diapos:[]
		}
		
		this.nodeXML=null;
		this.next();
		// this.setElementCourant();
		if(PROC){PROC.setObjet(this.name, this);}
		// this.start()
	}
	
	this.setElementCourant=function(){
		var name=this.nodeXML.getAttribute('name');
		switch(this.nodeXML.tagName.toLowerCase()){
			case 'agentdialogue':
				if(name in this.elements.personnages){
					this.element_courant=this.elements.personnages[name];
					this.element_courant.setAgentDialogue(this.nodeXML);
					this.element_courant.start();
				}
				else{
					this.createAgentByName(name);
				}
			break;
			case 'message':
				if(name in this.elements.messages){
					this.element_courant=this.elements.messages[name];
					this.element_courant.setMessage(this.nodeXML);
					this.element_courant.start();
				}
				else{
					this.element_courant=new Message(this.nodeXML);
					this.elements.messages[name]=this.element_courant;
				}
			break;
			case 'diapo':
				//patch à modifier : masque les diapos quand nouvelle
					var diapos=document.querySelectorAll("#theatre .Diapo");
					for(var i=0;i<diapos.length;i++){
						diapos[i].style.display='none';
					}
				//
				this.element_courant=new Diapo(this.nodeXML);
				this.elements.diapos.push(this.element_courant);			
			break;
			default:
				this.nodeXML.setAttribute('container', 'true');
				this.element_courant=this.dummy_element;
			break;
		}
		
	}
	
	this.next=function(){
		this.element_courant;
		this.nodeXML=PROC.next(this.nodeXML, this.XML);
		if(!this.nodeXML){
			this.fin();
		}
		else{
			this.setElementCourant();
		}
		return this.nodeXML;
	}
	
	
	this.createAgentByName=function(name){
		if(! name in optionsAgents){
			throw(name + " n'est pas un nom existant pour un Agent de Dialogue");
		}
		var options = optionsAgents[name];
		options.XML=this.nodeXML;//contient les dialogues
		this.element_courant=new agentDialogue(options);
		this.elements.personnages[name]=this.element_courant;			
	}
	
	this.loop=function() {
		if(this.pause || this.fini){return;}
		var that=this;
		window.requestAnimationFrame(function(){that.loop()});
		// this.update();
		if(this.element_courant.fini){
			this.next();
			if(!this.fini){this.element_courant.start();}
		}
	}
	
	this.afficher=function(){
		this.rootDOM.style.display="block";
	}
	
	this.cacher=function(){
		this.rootDOM.style.display='block';
	}
	
	this.start=function(){
		if(!this.pause){return;}
		this.afficher();
		this.pause=false;
		//à tester :
		for(var type in this.elements){
			for(var e in this.elements[type]){
				var el=this.elements[type][e];
				if('start' in el){
					delete el._pauseGlobale;
					el.start();
				}
			}
		}
		this.loop();
	}
	
	this.stop=function(){
		this.pause=true;
		//à tester :
		for(var type in this.elements){
			for(var e in this.elements[type]){
				var el=this.elements[type][e];
				if('stop' in el){
					el.stop();
					el._pauseGlobale=true;
				}
			}
		}
	}
	
	this.fin=function(){
		this.stop();
		this.fini=true;
		this.cacher();
	}
	
	// constructor(options){
	UTIL.setOptions(this, Scene.CONST.options_defaut);
	// UTIL.setOptions(this, options, Scene.CONST.options_defaut);
	
	this.initDOM();
	this.setScene(options);
		
	// }
	
}
Scene.CONST={
	options_defaut:{
		n:0,
		XML : null,
		transition:"fade",
		fini:false,
		pause:true
	}
}