/////////////////////////////////////
///           Sprite          ///
////////////////////////////////////

//class Sprite{
Sprite=function(options){	
	//initialisation(){
	this.initialisation=function(){
		var that=this;
		if(!this.imageURL){throw("imageURL nécessaire pour instancier le Sprite " + this.name);}
		if(!this.image){
			this.image=new Image();
			this.image.src=this.imageURL;
			this.image.onload=function(){that.imageLoaded=true;}			
		}
		
		//Si aucune séquence n'est décidée, on met toutes les Frames à la suite.
		if(!this.idFrames || this.idFrames.length==0){throw("Liste idFrames nécessaire pour instancier le Sprite " + this.name);}
		if(this.sequence.length==0){
			for(var i=0;i<this.idFrames.length;i++){this.sequence.push(i);}
		}
	}
	
	//affiche, lance le Sprites
	//start(){
	this.start=function(){
		if(!this.animation_lancee){
			this.render();
			this.animer();
			this.animation_lancee=true;
		} 
	}
	
	//Stoppe l'animation du Sprite (updates stoppés)
	// stop(){
	this.stop=function(){
		this.freeze=true;
	}
	
	//update(){
	this.update=function(){
		if(!this.imageLoaded){return false;}//on ne lance pas avant le chargement des images
		if(!this.freeze){//Sprite animé (yeux, bouche)
			var elapsed=Date.now() - this.now;
			if(this.n < this.sequence.length - 1){
				if(elapsed < this.dtFrame){return false;}
			}
			else{
				if(elapsed < (this.dtFrame + this.dtLoop)){return false;}
			}
			this.nprec=this.n;
			this.n = (this.n + 1) % this.sequence.length;
			this.now=new Date;
			return true;
		}		
		else{//sprites statiques (corps, tête)
			if(this.n!=this.nprec){
				this.nprec=this.n;
				return true;
			}
			else{
				return false;
			}
		}
		return false;
	}
	
	// render(){
	this.render=function(){
		//redessine le sprite à chaque appel
		var idframe=this.sequence[this.n];
		
		var sx=this.grille[this.idFrames[idframe]].x;
		var sy=this.grille[this.idFrames[idframe]].y;
		var sw=Math.min(this.grille[this.idFrames[idframe]].w, this.image.naturalWidth - sx);
		var sh=Math.min(this.grille[this.idFrames[idframe]].h, this.image.naturalHeight - sy);
		
		var dx=this.grille[this.idFrames[idframe]].tx;
		var dy=this.grille[this.idFrames[idframe]].ty;		
		var dw=this.grille[this.idFrames[idframe]].w;
		var dh=this.grille[this.idFrames[idframe]].h;
		
		
		this.context.clearRect(0, 0, this.width, this.height);
		
		// Draw the animation
		try{
			this.context.drawImage(
			   this.image,
			   sx,
			   sy,
			   sw,
			   sh,
			   dx,
			   dy,
			   dw,
			   dh
			   );
		}
		catch(e){
			console.log("___________________________________________");
			console.log("Erreur Image INDEX : " + this.name);
			console.log("sx=" + sx + " ; sy=" + sy + "sw=" + sw + " ; sh=" + sh);
			console.log("dx=" + dx + " ; dy=" + dy + "dw=" + dw + " ; dh=" + dh);
			console.log("natural width=" + this.image.naturalWidth + " ; natural height=" + this.image.naturalHeight);
			console.log("width=" + this.width + " ; height=" + this.height);
		}
		return this;
	}
	
	// animer() {
	this.animer=function(){
		var that=this;
			window.requestAnimationFrame(function(){that.animer();});
		if(this.update()){
			this.render();
		if(!this.animation_lancee){animation_lancee=true;}//moche
		}
	}
	
	//constructor(options){
	UTIL.setOptions(this, Sprite.CONST.options_defaut);
	UTIL.setOptions(this, options, Sprite.CONST.options_defaut);
	this.initialisation();
	//}
}

//constantes de la class Sprite
Sprite.CONST={
	options_defaut : {
		name:"",
		context : undefined,
		width : undefined,
		height : undefined,
		left:0,
		right:0,
		imageURL : undefined,
		image : undefined,
		imageLoaded : false,
		grille : undefined,
		idFrames:[],
		sequence:[],
		n:0,
		nprec:-1,
		//animation
		tickCount:0,
		ticksPerFrame:10,
		ticksBetweenLoops:0,
		loop:false,//définit si le sprite est  fait pour être animé
		freeze:true,
		now:Date.now(),
		dtFrame:0,
		dtLoop:0,//durée entre deux boucle du sprite
		animation_lancee:false
	}
}