window.requestAnimationFrame = window.requestAnimationFrame || function(callback) { window.setTimeout(callback,16) };

UTIL={
	RE : {
		num : new RegExp(/^[0-9]+(\.[0-9]*)?$/),
		alpha_num_name : new RegExp(/[a-zA-Z_]+[a-zA-Z0-9_]*/g)
	},
	numeric : function(str){
		return UTIL.RE.num.test(str);
	},
	alphaNumeric : function(str){
		return UTIL.RE.alpha_num_name.test(str);
	},
	isEmpty : function(o){
		if(Array.isArray(o)){return o.length==0;}
		else{
			for(var k in o){return false;}
			return true;
		}
	},
	isElement : function(e){
		if(!e){return false;}
		else if(!e.tagName && !e.nodeName){return false;}
		else{return true;}
	},
	prependChild : function(parent, newChild) {
		parent.insertBefore(newChild, parent.firstChild);
	},
	empty : function(e){
		while(e.lastChild){
			e.removeChild(e.lastChild);
		}
	},
	isParent : function(son, father, root){
		while(son){
			son=son.parentNode;
			if(son==father){
				return true;
			}
			if(root && son==root){return false;}
		}
		return false;
	},
	commonParent : function(a, b){
		var pa=[];
		while(a){
			pa[pa.length]=a;
			a= a.parentNode;
		}
		var L=pa.length;
		while(b){  
			for(var i=0; i<L; i++){
				if(pa[i]==b) return b;
			}
			b= b.parentNode;
		}
	},
	keys : function(o){
		if (!Object.keys) {
			var out = [];
			for (var k in o) {
				if (Object.prototype.hasOwnProperty.call(o, k)) {out.push(k);}
			}
			return out;
		}
		else{
			return Object.keys(o);
		}
	},
	//convertit <div id="avatar" class="agentDialogue" name="ava"> en {id:"avatar", class:"agentDialogue", name:"ava"}
	node2json : function(el){	
		var o={};
		for(var i=0;i<el.attributes.length;i++){
			var val=el.attributes[i].value;
			val=String(Number(val))==val ? Number(val) : val;
			o[el.attributes[i].name]=val;
		}
		return o;
	},
	//options peut être donné sous forme d'un noeud du DOM (ou de son "#id"), ou d'un json directement
	options2json : function(options){
		if(!options){return {};}
		else if(typeof options=="string"){
			try{
				var elDOM=document.querySelector(options);
			}
			catch(e){var elDOM=null;}
			if(elDOM){
				options=UTIL.node2json(elDOM);
				options.XML=elDOM;
			}
			else{
				return options;//on ne génère pas d'erreur
			}
		}
		if(typeof options=="object"){
			if(UTIL.isElement(options)){//DOM element, avec options sous forme d'attributs
				var elDOM=options;
				options=UTIL.node2json(elDOM);
				options.XML=elDOM;
			}
		}
		else{
			throw("Mauvais format pour les options : " + options);
		}
		return options;
	},
	findOrCreate : function(req, root){
		if(!root){root=document.querySelector("body");}
		var el=document.querySelector(req);
		if(!el){
			el=document.createElement("div");
			if(req[0]=='#'){
				el.id=req.substring(1);
			}
			else if(req[0]=='.'){
				el.className=req.substring(1);
			}
			root.appendChild(el);
		}
		return el;
	},
	setOptions : function(instance, options, options_defaut){//utiliser cette fonction pour modifier les options depuis l'extérieur, sinon problème de sync
		if(!options_defaut){var options_defaut=null;}
		for(var k in options){
			if(!options_defaut || (k in options_defaut)){
				instance[k] = options[k];
			}
		}
		return instance;
	},
	
	copyDiv : function(divfrom, div2){
		var nod=divfrom.firstChild;
		while(nod){
			var copy=nod.cloneNode(true)
			div2.appendChild(copy);
			nod=nod.nextSibling;
		}
		return div2;
	},
	addClass : function(node, classe){
		if(node.className.indexOf(classe)>-1){
			return node;
		}
		else{
			node.className = node.className + " " + classe;
			return node;
		}
	},
	removeClass : function(node, classe){
		if(node.className.indexOf(classe)==-1){
			return node;
		}
		else{
			var reg = new RegExp(" *"+classe+"*");
			node.className = node.className.replace(reg, ' ').trim();
			return node;
		}
	},
	setAttr : function(node, att, val, recursif){
		node.setAttribute(att, val);
		if(recursif){
			for(var i=0;i<node.children.length;i++){
				UTIL.setAttr(node.children[i], att, val, recursif);
			}
		}
	},
	removeAttr : function(node, att, recursif){
		node.removeAttribute(att);
		if(recursif){
			for(var i=0;i<node.children.length;i++){
				UTIL.removeAttr(node.children[i], att, recursif);
			}
		}
	},
	copyAttr : function(node_source, node_cible, exceptions){
		exceptions= exceptions ? exceptions : [];
		for(var i=0;i<node_source.attributes.length;i++){
			if(exceptions.indexOf(node_source.attributes[i].name)>-1){continue;}
			node_cible.setAttribute(node_source.attributes[i].name, node_source.attributes[i].value);
		}
	}
}