﻿preloadImages = {
	count: 0 /* keep track of the number of images */
	,loaded: 0 /* keeps track of how many images have loaded */
	,onComplete: function(){} /* fires when all images have finished loadng */
	,onLoaded: function(){} /*fires when an image finishes loading*/
	,loaded_image: "" /*access what has just been loaded*/
	,images: [] /*keeps an array of images that are loaded*/
	,incoming:[] /*this is for the process queue.*/
	/* this will pass the list of images to the loader*/
	,queue_images: function(images){
		//make sure to reset the counters
		this.loaded = 0;
		//reset the images array also
		this.images = [];
		//record the number of images
		this.count = images.length;
		//store the image names
		this.incoming = images;
		//start processing the images one by one
		this.process_queue();
	},
	process_queue: function(){
		//pull the next image off the top and load it
		this.load_image(this.incoming.shift());
	}/* this will load the images through the browser */,
	
	load_image: function(image){
		var that = this;
		var preload_image = new Image;

		preload_image.onload = function(){
			//store the loaded image so we can access the new info
			that.loaded_image = preload_image;

			//push images onto the stack
			that.images.push(preload_image);

			//note that the image loaded
			that.loaded +=1;

			//fire the onloaded
			(that.onLoaded)();

			//if all images have been loaded launch the call back
			if(that.count == that.loaded){
				document.querySelector("body").removeAttribute("loading");
				(that.onComplete)(); 
			}
			//load the next image
			else{
				that.process_queue();
			}
		}
	
	preload_image.src = image;
	}
}

function preloader(array_images_url){
	document.querySelector("body").setAttribute("loading","true");
	preloadImages.queue_images(array_images_url);
}


(function(DOMParser) {
	"use strict";

	var
	  proto = DOMParser.prototype
	, nativeParse = proto.parseFromString
	;

	// Firefox/Opera/IE throw errors on unsupported types
	try {
		// WebKit returns null on unsupported types
		if ((new DOMParser()).parseFromString("", "text/html")) {
			// text/html parsing is natively supported
			return;
		}
	} catch (ex) {}

	proto.parseFromString = function(markup, type) {
		if (/^\s*text\/html\s*(?:;|$)/i.test(type)) {
			var
			  doc = document.implementation.createHTMLDocument("")
			;
				if (markup.toLowerCase().indexOf('<!doctype') > -1) {
					doc.documentElement.innerHTML = markup;
				}
				else {
					doc.body.innerHTML = markup;
				}
			return doc;
		} else {
			return nativeParse.apply(this, arguments);
		}
	};
}(DOMParser));

function importXML(url){
	var body=document.querySelector("body")
	var xmlhttp=undefined;
	var parseXml;

	try{
		if (window.XMLHttpRequest){// code for IE7+, Firefox, Chrome, Opera, Safari
			xmlhttp=new XMLHttpRequest();
		}
		else		{// code for IE6, IE5
			xmlhttp=new ActiveXObject("Microsoft.XMLHTTP");
		}
		xmlhttp.open("GET",url+"?dummy="+Math.random(),false);
		xmlhttp.send();
		
		var sceneTxt=xmlhttp.responseText;
		var sceneTxtDummy=sceneTxt;
		
		sceneTxtDummy=sceneTxtDummy.replace(/condition *= *"[^"]+"/g,'condition="_"');		
		sceneTxtDummy=sceneTxtDummy.replace(/condition *= *'[^']+'/g,'condition=\'_\'');		
		
		var parser = new DOMParser();
		sceneXML = parser.parseFromString(sceneTxtDummy, "text/xml").querySelector("scene");
		sceneHtml = parser.parseFromString(sceneTxt, "text/html").querySelector("scene");
	
		var erreur=sceneXML ? sceneXML.querySelector("parsererror") : !sceneXML;
		if(erreur){
			var e=erreur.innerHTML + "<br/>";
			var parsererror=xmlhttp.responseXML.querySelectorAll("parsererror");
			if(parsererror.length>0){
				e+="debug analyseur XML (ignorer si position correspond à une condition='... <...') :<br/>"+parsererror[0].innerHTML;
			}
			throw e;
		}
	}
	catch(e){
		body.innerHTML=e;
		console.log(e);
		throw "Problème XMLHttpRequest" + e.toString();
	}
	return sceneHtml;
}

